VERSION 5.00
Begin VB.Form frmTable 
   Caption         =   "Math Cards"
   ClientHeight    =   4560
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6735
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   36
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4560
   ScaleWidth      =   6735
   StartUpPosition =   3  'Windows Default
   Tag             =   "Test"
   Begin VB.Timer tmWin 
      Left            =   1560
      Top             =   2520
   End
   Begin VB.PictureBox pbCard 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   1335
      Index           =   0
      Left            =   120
      ScaleHeight     =   1335
      ScaleWidth      =   1575
      TabIndex        =   0
      Top             =   240
      Visible         =   0   'False
      Width           =   1575
   End
   Begin VB.Menu mnuGame 
      Caption         =   "&Game"
      Begin VB.Menu mnuNew 
         Caption         =   "&New"
      End
      Begin VB.Menu mnuSpace1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
      Begin VB.Menu mnuFormula 
         Caption         =   "&Numbers"
         Index           =   0
      End
      Begin VB.Menu mnuFormula 
         Caption         =   "&Addition"
         Index           =   1
      End
      Begin VB.Menu mnuFormula 
         Caption         =   "&Subtraction"
         Index           =   2
      End
      Begin VB.Menu mnuFormula 
         Caption         =   "&Multiplication"
         Enabled         =   0   'False
         Index           =   3
      End
      Begin VB.Menu mnuFormula 
         Caption         =   "&Division"
         Enabled         =   0   'False
         Index           =   4
      End
      Begin VB.Menu mnuSpace2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuMinimum 
         Caption         =   "Mi&nimum Value"
      End
      Begin VB.Menu mnuMaximum 
         Caption         =   "Ma&ximum Value"
      End
      Begin VB.Menu mnuSpace4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSets 
         Caption         =   "Match Sets"
      End
      Begin VB.Menu mnuMatches 
         Caption         =   "Matches"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "frmTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type CardPos
    Left As Long
    Top As Long
End Type

'Enum For Available formulas for display
Private Enum FmlaOptions
    FO_Number = 1
    FO_Add = 2
    FO_Sub = 4
    FO_Mult = 8
    FO_Div = 16
End Enum

Private Fmlas       As FmlaOptions
Private MinVal      As Long
Private MaxVal      As Long
Private NumCards    As Long
Private NumMatch    As Long
Private TotCards    As Long
    
Private Player As Boolean
Private Score(0 To 1) As Integer

Private FlipCardIdx As Integer
Private CardOver    As Integer

Private Cards(0 To 3, 0 To 12) As CardPos
Private Fmla()      As String

Private Sub Form_Load()
On Error GoTo hard_error
    
    'Get Settings
    Fmlas = GetSetting("JetSoft", App.EXEName, "Formulas", FO_Number)
    MinVal = GetSetting("JetSoft", App.EXEName, "Minimum", 0)
    MaxVal = GetSetting("JetSoft", App.EXEName, "Maximum", 20)
    NumCards = GetSetting("JetSoft", App.EXEName, "Cards", 5)
    NumMatch = GetSetting("JetSoft", App.EXEName, "Matching", 4)
    
    'Start Random Number Generateor
    Randomize
    
    'Set up Menu
    mnuFormula(0).Checked = (Fmlas And FO_Number)
    mnuFormula(1).Checked = (Fmlas And FO_Add)
    mnuFormula(2).Checked = (Fmlas And FO_Sub)
    mnuFormula(3).Checked = (Fmlas And FO_Mult)
    mnuFormula(4).Checked = (Fmlas And FO_Div)
    mnuMinimum.Caption = "Mi&nimum Value (" & MinVal & ")"
    mnuMaximum.Caption = "Ma&ximum Value (" & MaxVal & ")"
    mnuSets.Caption = "Match Sets (" & NumCards & ")"
    mnuMatches.Caption = "Matches (" & NumMatch / 2 & ")"
Exit Sub
hard_error:
    'Subscript out of range
    If Err = 9 Then Resume
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    'Confirm if in game
    If pbCard.Count > 1 Then
        If vbYes <> MsgBox("Do you really want to quit?", vbYesNo Or vbDefaultButton2, "Quit") Then
            Cancel = True
            Exit Sub
        End If
    End If
    
    'Save Settings
    SaveSetting "JetSoft", App.EXEName, "Formulas", Fmlas & ""
    SaveSetting "JetSoft", App.EXEName, "Minimum", MinVal & ""
    SaveSetting "JetSoft", App.EXEName, "Maximum", MaxVal & ""
    SaveSetting "JetSoft", App.EXEName, "Cards", NumCards
    SaveSetting "JetSoft", App.EXEName, "Matching", NumMatch
End Sub

Private Sub Form_Resize()
On Error Resume Next
    Dim lngCard     As Long
    Dim lngWidth    As Long
    Dim lngHeight   As Long
    Dim objCard     As PictureBox

    'Determine Card Size from Image
    lngWidth = (Me.ScaleWidth / NumCards)
    lngHeight = (Me.ScaleHeight / NumMatch) - Screen.TwipsPerPixelY

    'Place Cards
    For Each objCard In pbCard
        lngCard = objCard.Index - 1
        If lngCard > -1 Then
            objCard.Move lngWidth * (lngCard \ NumMatch), lngHeight * (lngCard Mod NumMatch), lngWidth - Screen.TwipsPerPixelX, lngHeight - Screen.TwipsPerPixelY
            objCard.Visible = True
        End If
    Next
End Sub

Private Sub GameOver()
    
    'Show Winner
    Select Case Score(0) - Score(1)
        Case Is > 0:    Me.Tag = "Player 1 Wins!"
        Case Is < 0:    Me.Tag = "Player 2 Wins!"
        Case Else:      Me.Tag = "Tie Game"
    End Select

    'Start animation
    tmWin.Interval = 1

    Me.Caption = Me.Tag & "Player 1 (" & Score(0) & ") Player 2 (" & Score(1) & ")"
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuFormula_Click(Index As Integer)
    'Set Formula
    Fmlas = Fmlas Xor (2 ^ Index)
    
    'Set Check
    mnuFormula(Index).Checked = (Fmlas And (2 ^ Index))
End Sub

Private Sub mnuHelp_Click()
    'Show help form
    Dim frm As frmHelp
    Set frm = New frmHelp
    frm.Show vbModal, Me
    Set frm = Nothing
End Sub

Private Sub mnuMatches_Click()
    'Input Value
    NumMatch = Val(InputBox("Number of paired cards for each set", "Matches", NumMatch / 2)) * 2
    
    'Validate Value
    If NumMatch < 1 Then
        NumMatch = 2
        MsgBox "Value to small, adjusted to " & (NumMatch / 2), vbOKOnly Or vbInformation, "Value Changed"
    End If
    
    'Set Caption
    mnuMatches.Caption = "Matches (" & NumMatch / 2 & ")"

End Sub

Private Sub mnuMaximum_Click()
    'Input Value
    MaxVal = Val(InputBox("Maximum allowed value", "Maximum Value", MaxVal))
    
    'Validate Value
    If MaxVal < (MinVal - NumCards) Then
        MaxVal = MinVal - NumCards
        MsgBox "Value to small, adjusted to " & MaxVal, vbOKOnly Or vbInformation, "Value Changed"
    End If
    
    'Set Caption
    mnuMaximum.Caption = "Ma&ximum Value (" & MaxVal & ")"
End Sub

Private Sub mnuMinimum_Click()
    'Input Value
    MinVal = Val(InputBox("Minimum allowed value", "Minimum Value", MinVal))
    
    'Validate Value
    If MinVal > (MaxVal - NumCards) Then
        MinVal = MaxVal - NumCards
        MsgBox "Value to large, adjusted to " & MinVal, vbOKOnly Or vbInformation, "Value Changed"
    End If

    'Set Caption
    mnuMinimum.Caption = "Mi&nimum Value (" & MinVal & ")"
End Sub

Private Sub mnuNew_Click()
On Error GoTo hard_error
    
    Dim CardNum     As Long
    Dim colCards    As Collection
    Dim colTotals   As Collection
    Dim MatchSet    As Long
    Dim Match       As Long
    Dim ValTot      As Long
    Dim Val1        As Long
    Dim Idx         As Integer
    Dim Card        As Long
    
    'Confirm if in game
    If pbCard.Count > 1 Then
        If vbYes <> MsgBox("Do you really want to start a new game ?", vbYesNo Or vbDefaultButton2, "Quit") Then Exit Sub
    End If
    
    'Clear Animation
    tmWin.Interval = 0

    'remove old cards
    Do Until pbCard.Count = 1
        Unload pbCard(pbCard.UBound)
    Loop

    'No Card Flipped
    FlipCardIdx = 0
    
    'Determine total Number of cards and formulas
    TotCards = NumCards * NumMatch
    ReDim Fmla(0 To TotCards - 1)
    
    'Build Collection of Cards
    Set colCards = New Collection
    For Idx = 0 To TotCards - 1
        colCards.Add Idx, CStr(Idx)
    Next
        
    'Build collection of available totals
    Set colTotals = New Collection
    For Idx = MinVal To MaxVal
        colTotals.Add Idx, CStr(Idx)
    Next
        
    'set up Formulas
    For MatchSet = 0 To NumCards - 1
        'Determine total
        ValTot = colTotals(Rnd * colTotals.Count + 1)
        colTotals.Remove CStr(ValTot)
        Debug.Print MatchSet, ValTot

        'Generate Formula
        For Match = 0 To NumMatch - 1
            'Determine card number
            Card = MatchSet * NumMatch + Match

            'Loop until formula generated
            Do
                Select Case 2 ^ CInt(Rnd * 5)
                    Case FO_Number
                        'Use number if enabled
                        If Fmlas And FO_Number Then
                            Fmla(Card) = ValTot
                            Exit Do
                        End If
                    Case FO_Add
                        'Add if enabled
                        If Fmlas And FO_Add Then
                            Val1 = CInt(Rnd * (ValTot - MinVal) + MinVal)
                            Fmla(Card) = Val1 & " + " & (ValTot - Val1)
                            Exit Do
                        End If
                    Case FO_Sub
                        'Subtract if enabled
                        If Fmlas And FO_Sub Then
                            Val1 = CInt(Rnd * (MaxVal - ValTot) + ValTot)
                            Fmla(Card) = Val1 & " - " & (Val1 - ValTot)
                            Exit Do
                        End If
'                    Case FO_Mult
'                    Case FO_Div
                End Select
            Loop
            Debug.Print , Fmla(Card)
        Next 'Match
    Next 'MatchSet
    
    'Determine Card References
    For Idx = 1 To TotCards
        'Determine Card from deck
        CardNum = colCards(Rnd() * colCards.Count + 1)
        colCards.Remove CStr(CardNum)
        
        'Load Card.  Tag is used to keep card reference
        Load pbCard(Idx)
        pbCard(Idx).Tag = CardNum + TotCards 'Indicates show back side
    Next
    
    'Size screen based on cards
    Form_Resize
    Player = False
    Score(0) = 0
    Score(1) = 0
    ShowScore 0
    Me.ForeColor = RGB(0, 0, 0)
Exit Sub
hard_error:
    'Subscript out of range
    If Err = 9 Then Resume
End Sub

Private Sub mnuSets_Click()
    'Input Value
    NumCards = Val(InputBox("Number of match sets", "Match Sets", NumCards))
    
    'Validate Value
    If NumCards > (MaxVal - MinVal) Then
        NumCards = MaxVal - MinVal
        MsgBox "Value to large, adjusted to " & NumCards, vbOKOnly Or vbInformation, "Value Changed"
    End If

    'Set Caption
    mnuSets.Caption = "Match Sets (" & NumCards & ")"
End Sub

Private Sub pbCard_DragDrop(Index As Integer, Source As Control, X As Single, Y As Single)
    'End Dragging.  Flip Card dropped on.  MouseUp Event check's matches
    Source.Drag vbEndDrag
    If Index <> Source.Index Then
        If CardOver > 0 Then pbCard_Paint CardOver 'Clear card
        
        'Flip First if not already flipped
        If FlipCardIdx = 0 Then pbCard_MouseUp Source.Index, vbLeftButton, 0, 0, 0
        
        'Flip this card
        pbCard_MouseUp Index, vbLeftButton, 0, X, Y
    End If
End Sub

Private Sub pbCard_DragOver(Index As Integer, Source As Control, X As Single, Y As Single, State As Integer)
    'Highlight card on move
    If Index <> Source.Index Then
        If CardOver > 0 Then pbCard_Paint CardOver 'Clear card
        pbCard(Index).DrawMode = vbInvert
        pbCard(Index).Line (0, 0)-(pbCard(Index).ScaleWidth, pbCard(Index).ScaleHeight), , BF
        CardOver = Index    'Set This as card over
    End If
End Sub

Private Sub pbCard_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Begin Dragging if button is pressed and move is outside the card area
    If Button = vbLeftButton Then
        'Exit if this is not the selected card and one already flipped
        If (FlipCardIdx > 0) And (FlipCardIdx <> Index) Then Exit Sub
        
        'See if move outside card area, begin dragging
        If (X < 0) Or (X > pbCard(Index).Width) Or (Y < 0) Or (Y > pbCard(Index).Height) Then
            pbCard(Index).Drag vbBeginDrag
        End If
    End If
End Sub

Private Sub pbCard_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim CardNum As Integer
    Dim etime As Date
    If Button = vbLeftButton Then
        'Do Nothing on Same Flip card click
        If Index = FlipCardIdx Then Exit Sub
                
        'Flip Card
        pbCard(Index).Tag = pbCard(Index).Tag Mod TotCards
        pbCard_Paint Index
        
        If FlipCardIdx = 0 Then
            'This is the first card, flip
            FlipCardIdx = Index
        Else
            'This is the second card
            'Pause for a few seconds
            etime = DateAdd("s", 2, Now)
            Do Until etime < Now
            Loop

            'Choose actions
            If (pbCard(Index).Tag \ NumMatch) = (pbCard(FlipCardIdx).Tag \ NumMatch) Then
                'Cards Match - Remove Cards
                Unload pbCard(FlipCardIdx)
                Unload pbCard(Index)
    
                'Give player a point
                ShowScore 1
                
                'Indicate win
                If pbCard.Count = 1 Then GameOver
            Else
                'Flip Reference card
                pbCard(FlipCardIdx).Tag = Val(pbCard(FlipCardIdx).Tag) + TotCards
                pbCard_Paint FlipCardIdx
            
                'Flip This Card
                pbCard(Index).Tag = Val(pbCard(Index).Tag) + TotCards
                pbCard_Paint Index
            
                'Update Display
                ShowScore 0
            End If
        
            'Clear indicator
            FlipCardIdx = 0
        End If
    End If
End Sub

Private Sub pbCard_Paint(Index As Integer)
    'Redraw image based on the tag representing the card number
    Dim sText   As String
    Dim lngCard As Long
    
    'Determine card reference
    lngCard = pbCard(Index).Tag
    
    'Determine what to show
    pbCard(Index).DrawMode = vbCopyPen
    pbCard(Index).DrawWidth = 5
    If lngCard < TotCards Then
        'Draw Front
        pbCard(Index).Line (0, 0)-(pbCard(Index).Width, pbCard(Index).Height), RGB(255, 255, 255), BF
        pbCard(Index).Line (0, 0)-(pbCard(Index).Width, pbCard(Index).Height), RGB(0, 0, 255), B
    
        'Add Text
        sText = Fmla(lngCard)
        pbCard(Index).CurrentX = (pbCard(Index).ScaleWidth - pbCard(Index).TextWidth(sText)) / 2
        pbCard(Index).CurrentY = (pbCard(Index).ScaleHeight - pbCard(Index).TextHeight(sText)) / 2
        pbCard(Index).Print sText
    Else
        'Draw Back
        pbCard(Index).Line (0, 0)-(pbCard(Index).Width, pbCard(Index).Height), RGB(128, 128, 255), BF
        pbCard(Index).Line (0, 0)-(pbCard(Index).Width, pbCard(Index).Height), RGB(0, 0, 0), B
    End If
End Sub

Private Sub ShowScore(AddScore As Integer)
    'Add Score
    Score(IIf(Player, 0, 1)) = Score(IIf(Player, 0, 1)) + AddScore
    
    'Swap Players
    Player = Not Player
    
    'Show Caption
    Me.Caption = "Player 1 (" & Score(0) & ") Player 2 (" & Score(1) & ") :  Player " & IIf(Player, 1, 2) & "'s Turn"
End Sub

Private Sub tmWin_Timer()
    'Force Proper timer interval
    'tmWin.Interval = 1
    
    
    Dim lngPos As Long
    
    'Determine Index
    Me.ScaleMode = vbPixels
    lngPos = Rnd * (Me.ScaleWidth + Me.ScaleHeight) - Me.ScaleWidth
    
    'draw line
    Me.DrawWidth = Rnd * 10 + 1
    
    If lngPos < 0 Then
        'draw across
        Me.Line (-lngPos, 0)-(Me.ScaleWidth + lngPos, Me.ScaleHeight), RGB(Rnd * 256, Rnd * 256, Rnd * 256)
    Else
        'draw down
        Me.Line (0, lngPos)-(Me.ScaleWidth, Me.ScaleHeight - lngPos), RGB(Rnd * 256, Rnd * 256, Rnd * 256)
    End If
    
    'Put Victory Text up
    Me.ForeColor = RGB(Rnd * 256, Rnd * 256, Rnd * 256)
    Me.CurrentX = (Me.ScaleWidth - TextWidth(Me.Tag)) / 2
    Me.CurrentY = (Me.ScaleHeight - TextHeight(Me.Tag)) / 2
    Me.Print Me.Tag
End Sub
